/*
 *  cMoHist.h
 *  MotionHistogram
 *
 *  Created by Kris Kitani on 5/25/11. (kkitani@cs.cmu.edu)
 *  Copyright 2011 Kris Kitani. All rights reserved.
 *
 */

#ifndef EXTRACT_MOHIST_H
#define EXTRACT_MOHIST_H

#include <list>
#include <iostream>
#include <fstream>
#include <opencv2/opencv.hpp>

using namespace std;

class cMoHist{

public:
	cMoHist();
	~cMoHist();
	
	int getDims();
	int numDirectionalBins;
	int numTotalBins;
	int numMagBins;
	int numVarBins;
	int numOriBins;
	int numFreqX;
	int numFreqY;
	int numFreqBins;
	
	float avgmag_threshold;
	float var_threshold;
	float mag_threshold;
	
	int dft_window_size;
	
	int max_ori;
	float ori_bin_width;
	float ori_shift;
	
	void computeMotionFeature(CvPoint2D32f *cur,CvPoint2D32f *prv,int count, double **motvec);
	float projection_error;	
	
	int t_freq_x;
	int t_freq_y;
	
	list<float> sigX;
	list<float> sigY;
	vector<float> vsig;
	
	cv::Mat src;
	cv::Mat_<float> _src;
	
	float *norm_max_X;
	float *norm_max_Y;
	
	void drawFlow(CvPoint2D32f *cur,CvPoint2D32f *prv, int count, IplImage *frm);
	CvMat *stat;
	
	void writeToFile(string filename, double **motvec);
	ofstream outstream;
	string outputfile;
	int f;
	
};

#endif


